#ifndef		_INTERSECT_H_
#define		_INTERSECT_H_

#include	"Vector.h"
#include	"Volumes.h"

class	clIntersect
{

public:

	//     
	void	funcGetIntervalSphere		( clSphere a, clVec2 axis, float & fMin, float & fMax );
	void	funcGetIntervalLine			( clLine a, clVec2 axis, float & fMin, float & fMax );
	void	funcGetIntervalAABB			( clAABB a, clVec2 axis, float & fMin, float & fMax );
	void	funcGetIntervalOBB			( clOBB a, clVec2 axis, float & fMin, float & fMax );

	//   true   
	bool	funcIntersectAABBxAABB		( clAABB & a0, clAABB & a1 );	// AABB x AABB
	bool	funcIntersectAABBxSphere	( clAABB & a0, clSphere & a1, clVec2 & v );	// AABB x Sphere
	bool	funcIntersectSpherexSphere	( clSphere & a0, clSphere & a1, clVec2 & v );	// Sphere x Sphere
	bool	funcIntersectSpherexLine	( clSphere & a0, clLine & a1, clVec2 & v );	// Sphere x Line segment
	bool	funcIntersectSpherexOBB		( clSphere & a0, clOBB & a1, clVec2 & v );	// Sphere x OBB
	bool	funcIntersectAABBxLine		( clAABB & a0, clLine & a1, clVec2 & v );	// AABB x Line segment
	bool	funcIntersectOBBxLine		( clOBB & a0, clLine & a1, clVec2 & v );	// OBB x Line segment
	bool	funcIntersectLinexLine		( clLine & a0, clLine & a1, clVec2 & v );	// Line segment x Line segment
	bool	funcIntersectAABBxOBB		( clAABB & a0, clOBB & a1, clVec2 & v );	// AABB x OBB
	bool	funcIntersectOBBxOBB		( clOBB & a0, clOBB & a1, clVec2 & v );	// OBB x OBB

private:

};

#endif		// _INTERSECT_H_