#include	"Volumes.h"

// AABB

void clAABB::funcRender( void )
{
	clVec2	v[ 4 ];

	v[ 0 ].VecSet( vPos.x - vSiz.x, vPos.y - vSiz.y );
	v[ 1 ].VecSet( vPos.x - vSiz.x, vPos.y + vSiz.y );
	v[ 2 ].VecSet( vPos.x + vSiz.x, vPos.y + vSiz.y );
	v[ 3 ].VecSet( vPos.x + vSiz.x, vPos.y - vSiz.y );

	glBegin( GL_LINE_LOOP );
		glVertex2fv( ( float * )&v[ 0 ] );
		glVertex2fv( ( float * )&v[ 1 ] );
		glVertex2fv( ( float * )&v[ 2 ] );
		glVertex2fv( ( float * )&v[ 3 ] );
	glEnd();
}

// Circle

void clSphere::funcRender( int iCount )
{
	float			fTemp = ( 6.48 / iCount );

	glBegin( GL_LINE_LOOP );
		for( int i = 0; i < iCount; i++ )
		{
			glVertex2f( vPos.x + cos( i * fTemp ) * fRadius,
				        vPos.y + sin( i * fTemp ) * fRadius );
		} 
	glEnd();
}

// Line

void clLine::funcRender( void )
{
	glBegin( GL_LINES );
		glVertex2fv( ( float * )&( this->vMid - ( this->vDir * this->fHalf ) ) );
		glVertex2fv( ( float * )&( this->vMid + ( this->vDir * this->fHalf ) ) );
	glEnd();
}

// OBB

void clOBB::funcRender( void )
{
	clVec2	v[ 4 ];
	clVec2	r[ 4 ];

	r[ 0 ].VecSet( - vSiz.x, - vSiz.y );
	r[ 1 ].VecSet( - vSiz.x, + vSiz.y );
	r[ 2 ].VecSet( + vSiz.x, + vSiz.y );
	r[ 3 ].VecSet( + vSiz.x, - vSiz.y );

	r[ 0 ].VecRotate( fAngle );
	r[ 1 ].VecRotate( fAngle );
	r[ 2 ].VecRotate( fAngle );
	r[ 3 ].VecRotate( fAngle );

	v[ 0 ] = vPos + r[ 0 ];
	v[ 1 ] = vPos + r[ 1 ];
	v[ 2 ] = vPos + r[ 2 ];
	v[ 3 ] = vPos + r[ 3 ];

	glBegin( GL_LINE_LOOP );
		glVertex2fv( ( float * )&v[ 0 ] );
		glVertex2fv( ( float * )&v[ 1 ] );
		glVertex2fv( ( float * )&v[ 2 ] );
		glVertex2fv( ( float * )&v[ 3 ] );
	glEnd();
}
