/* ===============================================================================================
 *         
 * -----------------------------------------------------------------------------------------------
 * AABB x AABB
 * AABB x 
 *  x 
 *  x 
 *  x OBB
 * AABB x 
 * OBB x 
 *  x 
 * AABB x OBB
 * OBB x OBB
 * -----------------------------------------------------------------------------------------------
 *     
 *		15.10.2006 (C) faceH0r
 *		.    
 * ===============================================================================================
 */

#pragma comment( lib, "opengl32.lib" )
#pragma comment( lib, "glu32.lib" )
#pragma comment( lib, "glaux.lib" )

#include	<windows.h>

#include	<gl/gl.h>

#include	"Vector.h"
#include	"Volumes.h"
#include	"Intersect.h"

#include	<stdio.h>
#include	<math.h>

HDC			hDc;
HGLRC		hRc;

float		fCurTime;
float		fDelTime;
float		fOldTime;

bool		bKeys[ 256 ];

int			iState = 0;
float		fSpeed = 0.001f;

clSphere	sph		[ 4 ];
clAABB		aabb	[ 4 ];
clOBB		obb		[ 4 ];
clLine		line	[ 4 ];

clIntersect	cl;

void		funcGenerate	( void )
{
	int		i = 0;

	//   
	for( i = 0; i < 3; i ++ )
	{
		sph[ i ].vPos.VecSet( ( rand() % 100 - 50 ) / 100.0f, ( rand() % 100 - 50 ) / 100.0f );
		sph[ i ].fRadius = ( rand() % 100 ) / 300.0f;
	}

	//   
	for( i = 0; i < 3; i ++ )
	{
		aabb[ i ].vPos.VecSet( ( rand() % 100 - 50 ) / 100.0f, ( rand() % 100 - 50 ) / 100.0f );
		aabb[ i ].vSiz.VecSet( ( rand() % 100 ) / 400.0f, ( rand() % 100 ) / 400.0f );
	}

	//   
	for( i = 0; i < 3; i ++ )
	{
		line[ i ].vMid.VecSet( ( rand() % 100 - 50 ) / 100.0f, ( rand() % 100 - 50 ) / 100.0f );
		line[ i ].fHalf = ( rand() % 100 ) / 400.0f;
		line[ i ].vDir.VecSet( 1.0f, 0.0f );
		line[ i ].vDir.VecRotate( 3.14 * ( rand() % 100 ) / 100.0f );
	}

	//    
	for( i = 0; i < 3; i ++ )
	{
		obb[ i ].vPos.VecSet( ( rand() % 100 - 50 ) / 100.0f, ( rand() % 100 - 50 ) / 100.0f );
		obb[ i ].vSiz.VecSet( ( rand() % 100 ) / 400.0f, ( rand() % 100 ) / 400.0f );
		obb[ i ].fAngle = 3.14 * ( ( rand() % 100 ) / 100.0f );
	}

	//  ,   
	sph[ 3 ].vPos.VecZero();
	sph[ 3 ].fRadius = ( rand() % 100 ) / 300.0f + 0.01f;

	//  ,   
	line[ 3 ].vMid.VecZero();
	line[ 3 ].vDir.VecSet( 1.0f, 0.0f );
	line[ 3 ].fHalf = ( rand() % 100 ) / 600.0f;

	//  OBB
	obb[ 3 ].vPos.VecZero();;
	obb[ 3 ].vSiz.VecSet( ( rand() % 100 ) / 400.0f, ( rand() % 100 ) / 400.0f );
	obb[ 3 ].fAngle = 3.14 * ( ( rand() % 100 ) / 100.0f );
}

void SetDCPixelFormat( HDC hDc )
{
	PIXELFORMATDESCRIPTOR		pfd;
	int							nPixelFormat;

	memset( &pfd, 0, sizeof( PIXELFORMATDESCRIPTOR ) );
	pfd.dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER;
	nPixelFormat = ChoosePixelFormat( hDc, &pfd );
	SetPixelFormat( hDc, nPixelFormat, &pfd );
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
	switch( uMsg )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			PostQuitMessage( 0 );

			break;
		case VK_SPACE:
			funcGenerate();

			break;
		}

		bKeys[ wParam ] = true;

		break;
	case WM_KEYUP:
		bKeys[ wParam ] = false;

		break;
	case WM_CLOSE:
		PostQuitMessage( 0 );

		break;
	case WM_CREATE:
		hDc = GetDC( hWnd );
		SetDCPixelFormat( hDc );
		hRc = wglCreateContext( hDc );

		wglMakeCurrent( hDc, hRc );

		srand( GetTickCount() );

		funcGenerate();

		break;
	default:
		return DefWindowProc( hWnd, uMsg, wParam, lParam );
	}
}

void funcCircleMain( void )
{
	clVec2	vPush;

	int		i;

	if( bKeys[ VK_UP ] )
	{
		sph[ 3 ].vPos += clVec2( 0.0f, fSpeed ) * fDelTime;
	}
	if( bKeys[ VK_DOWN ] )
	{
		sph[ 3 ].vPos -= clVec2( 0.0f, fSpeed ) * fDelTime;
	}
	if( bKeys[ VK_LEFT ] )
	{
		sph[ 3 ].vPos -= clVec2( fSpeed, 0.0f ) * fDelTime;
	}
	if( bKeys[ VK_RIGHT ] )
	{
		sph[ 3 ].vPos += clVec2( fSpeed, 0.0f ) * fDelTime;
	}

	//      ,   
	for( i = 0; i < 3; i ++ )
	{
		//       
		if( cl.funcIntersectSpherexSphere( sph[ 3 ], sph[ i ], vPush ) )
		{
			//   
			glColor3f( 1.0f, 0.0f, 0.0f );

			sph[ 3 ].vPos += vPush;
		}
		else
		{
			//   
			glColor3f( 1.0f, 1.0f, 1.0f );
		}
		//  
		sph[ i ].funcRender( 32 );
	}
	//    
	for( i = 0; i < 3; i ++ )
	{
		//      
		if( cl.funcIntersectAABBxSphere( aabb[ i ], sph[ 3 ], vPush ) )
		{
			//   
			glColor3f( 1.0f, 0.0f, 0.0f );

			sph[ 3 ].vPos += vPush;
		}
		else
		{
			//   
			glColor3f( 1.0f, 1.0f, 1.0f );
		}
		//  
		aabb[ i ].funcRender();
	}
	//    
	for( i = 0; i < 3; i ++ )
	{
		//      
		if( cl.funcIntersectSpherexLine( sph[ 3 ], line[ i ], vPush ) )
		{
			//   
			glColor3f( 1.0f, 0.0f, 0.0f );

			sph[ 3 ].vPos -= vPush;
		}
		else
		{
			//   
			glColor3f( 1.0f, 1.0f, 1.0f );
		}
		//  
		line[ i ].funcRender();
	}
	//     
	for( i = 0; i < 3; i ++ )
	{
		//      
		if( cl.funcIntersectSpherexOBB( sph[ 3 ], obb[ i ], vPush ) )
		{
			//   
			glColor3f( 1.0f, 0.0f, 0.0f );

			sph[ 3 ].vPos += vPush;
		}
		else
		{
			//   
			glColor3f( 1.0f, 1.0f, 1.0f );
		}
		//  
		obb[ i ].funcRender();
	}
	//     
	glColor3f( 0.0f, 1.0f, 0.0f );
	sph[ 3 ].funcRender( 32 );
}

void funcLineMain( void )
{
	int		i;

	clVec2	vPush;

	if( bKeys[ VK_UP ] )
	{
		line[ 3 ].vMid += clVec2( 0.0f, fSpeed ) * fDelTime;
	}
	if( bKeys[ VK_DOWN ] )
	{
		line[ 3 ].vMid -= clVec2( 0.0f, fSpeed ) * fDelTime;
	}
	if( bKeys[ VK_LEFT ] )
	{
		line[ 3 ].vMid -= clVec2( fSpeed, 0.0f ) * fDelTime;
	}
	if( bKeys[ VK_RIGHT ] )
	{
		line[ 3 ].vMid += clVec2( fSpeed, 0.0f ) * fDelTime;
	}
	if( bKeys[ 'Q' ] )
	{
		line[ 3 ].vDir.VecRotate( 0.005f * fDelTime );
	}
	if( bKeys[ 'W' ] )
	{
		line[ 3 ].vDir.VecRotate( - 0.005f * fDelTime );
	}

	//  
	for( i = 0; i < 3; i ++ )
	{
		if( cl.funcIntersectSpherexLine( sph[ i ], line[ 3 ], vPush ) )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );

			line[ 3 ].vMid += vPush;
		}
		else
		{
			glColor3f( 1.0f, 1.0f, 1.0f );
		}

		sph[ i ].funcRender( 32 );
	}

	// 
	for( i = 0; i < 3; i ++ )
	{
		if( cl.funcIntersectAABBxLine( aabb[ i ], line[ 3 ], vPush ) )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );

			line[ 3 ].vMid += vPush;
		}
		else
		{
			glColor3f( 1.0f, 1.0f, 1.0f );
		}

		aabb[ i ].funcRender();
	}

	//  
	for( i = 0; i < 3; i ++ )
	{
		if( cl.funcIntersectOBBxLine( obb[ i ], line[ 3 ] , vPush ) )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );

			line[ 3 ].vMid += vPush;
		}
		else
		{
			glColor3f( 1.0f, 1.0f, 1.0f );
		}

		obb[ i ].funcRender();
	}

	//    ?      
	for( i = 0; i < 3; i ++ )
	{
		clVec2		vPush;

		if( cl.funcIntersectLinexLine( line[ i ], line[ 3 ], vPush ) )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );

			line[ 3 ].vMid += vPush;
		}
		else
		{
			glColor3f( 1.0f, 1.0f, 1.0f );
		}

		line[ i ].funcRender();
	}

	//   
	glColor3f( 0.0f, 1.0f, 0.0f );
	line[ 3 ].funcRender();
}

void funcOBBMain( void )
{
	clVec2	vPush;
	int		i;

	if( bKeys[ VK_UP ] )
	{
		obb[ 3 ].vPos += clVec2( 0.0f, fSpeed ) * fDelTime;
	}
	if( bKeys[ VK_DOWN ] )
	{
		obb[ 3 ].vPos -= clVec2( 0.0f, fSpeed ) * fDelTime;
	}
	if( bKeys[ VK_LEFT ] )
	{
		obb[ 3 ].vPos -= clVec2( fSpeed, 0.0f ) * fDelTime;
	}
	if( bKeys[ VK_RIGHT ] )
	{
		obb[ 3 ].vPos += clVec2( fSpeed, 0.0f ) * fDelTime;
	}
	if( bKeys[ 'Q' ] )
	{
		obb[ 3 ].fAngle += 0.005f * fDelTime;
	}
	if( bKeys[ 'W' ] )
	{
		obb[ 3 ].fAngle -= 0.005f * fDelTime;
	}

	//  
	for( i = 0; i < 3; i ++ )
	{
		if( cl.funcIntersectSpherexOBB( sph[ i ], obb[ 3 ], vPush ) )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );

			obb[ 3 ].vPos -= vPush;
		}
		else
		{
			glColor3f( 1.0f, 1.0f, 1.0f );
		}

		sph[ i ].funcRender( 32 );
	}

	// 
	for( i = 0; i < 3; i ++ )
	{
		if( cl.funcIntersectOBBxLine( obb[ 3 ], line[ i ], vPush ) )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );

			obb[ 3 ].vPos -= vPush;
		}
		else
		{
			glColor3f( 1.0f, 1.0f, 1.0f );
		}

		line[ i ].funcRender();
	}

	// 
	for( i = 0; i < 3; i ++ )
	{
		if( cl.funcIntersectAABBxOBB( aabb[ i ], obb[ 3 ], vPush  ) )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );

			obb[ 3 ].vPos += vPush;
		}
		else
		{
			glColor3f( 1.0f, 1.0f, 1.0f );
		}

		aabb[ i ].funcRender();
	}

	//  
	for( i = 0; i < 3; i ++ )
	{
		if( cl.funcIntersectOBBxOBB( obb[ i ], obb[ 3 ], vPush ) )
		{
			glColor3f( 1.0f, 0.0f, 0.0f );

			obb[ 3 ].vPos += vPush;
		}
		else
		{
			glColor3f( 1.0f, 1.0f, 1.0f );
		}

		obb[ i ].funcRender();
	}

	//  OBB
	glColor3f( 0.0f, 1.0f, 0.0f );
	obb[ 3 ].funcRender();
}

WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd )
{
	WNDCLASSEX		wclass;
	MSG				msg;
	HWND			hWnd;

	memset( &wclass, 0,sizeof( WNDCLASSEX ) );
	memset( &msg, 0, sizeof( MSG ) );

	wclass.cbSize = sizeof( WNDCLASSEX );
	wclass.lpfnWndProc = WndProc;
	wclass.lpszClassName = "CCollide";

	RegisterClassEx( &wclass );

	hWnd = CreateWindowEx( 0, "CCollide", "Coll", WS_POPUP, 0, 0, 1024, 768, 0, 0, 0, 0 );

	ShowWindow( hWnd, SW_SHOW );

	ShowCursor( false );

	fOldTime = GetTickCount();

	while( msg.message != WM_QUIT )
	{
		if( PeekMessage( &msg, 0, 0, 0, PM_REMOVE ) )
		{
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
		else
		{
			fCurTime = GetTickCount();
			fDelTime = fCurTime - fOldTime;
			fOldTime = fCurTime;

			glClear( GL_COLOR_BUFFER_BIT );

			if( bKeys[ '1' ] )
			{
				iState = 0;
			}
			if( bKeys[ '2' ] )
			{
				iState = 1;
			}
			if( bKeys[ '3' ] )
			{
				iState = 2;
			}

			switch( iState )
			{
			case 0:
				funcCircleMain();

				break;
			case 1:
				funcLineMain();

				break;
			case 2:
				funcOBBMain();

				break;
			}

			SwapBuffers( hDc );
		}
	}

	return 0;
}